/*
 *  FindingVisitor.cpp
 *  testingTinyXMLandCollada
 *
 *  Created by Matt Evett on 4/18/12.
 *  Copyright 2012 Eastern Michigan Univ. All rights reserved.
 *
 */

#include "tinyxml.h"
#include "FindingVisitor.h"

bool FindingVisitor::VisitEnter( const TiXmlElement& element, const TiXmlAttribute* firstAttribute )	{ 

	if (elementFound_p)  // Hack to stop recursion once solution is found
		return false;
	
	const char* elementName = element.Value();
	
	if (!preTargetName || (preTargetName && preElementFound_p)) {   // If we're not working with a context, or
		// the context has been found
	
		if (strcmp(elementName,targetName)==0) {
			elementFound_p = true;
			valueOfFoundElement = element.GetText();
			return false; }  // Stop recursion
	}
	else {  //We are working with a context but it's not yet found
		if (strcmp(elementName,preTargetName)==0) {
			preElementFound_p = true;
		}
	}
	return true;
}
		
